/*
*********************************************
*                                           *
*  NZEV SOUBORU: image.h                   *
*  AUTOR:         Michal (Sirall) ervenka  *
*  E-MAIL:        cervem5@fel.cvut.cz       *
*                                           *
*********************************************
*/

#ifndef __IMAGE_H
#define __IMAGE_H

#include <stdio.h>
#include <iostream>
#include <windows.h>
#include <GL/gl.h>

const DWORD bitmapID = 0x4D42;

struct Image {
public:
    unsigned int    iWidth;
    unsigned int    iHeight;
    unsigned int    iBpp;
    unsigned int    iFormat;
    unsigned char   *pData;
    unsigned int    iStride;

	bool            bPaletted;
	unsigned int    iPaletteFormat;
	unsigned int    iPaletteBpp;
	unsigned char   *pPalette;
    
public:
    Image();
    ~Image();
   
    void expandPalette();    
};

Image *LoadBMP(char *filename); // Hlavn natac funkce pro bmp (vol fce Load24BitBMP a Load8BitBMP dle poteby)
Image *Load24BitBMP(char *filename);
Image *Load8BitBMP(char *filename);
Image *LoadTGA(char *filename); // Hlavn natac funkce pro tga (vol fce LoadUncompressedTrueColorTGA, LoadUncompressed8BitTGA a LoadCompressedTrueColorTGA dle poteby)
Image *LoadUncompressedTrueColorTGA(char * filename, int idLength);
Image *LoadUncompressed8BitTGA(char * filename, int idLength);
Image *LoadCompressedTrueColorTGA(char *filename, int idLength);

#endif
