#ifndef OBJEKTY_H_INCLUDED
#define OBJEKTY_H_INCLUDED

#include "extern/glm.h"
#include "primitiva/kour.h"
#include "primitiva/primitiva.h"
void drawModel(char* filename, GLMmodel* model);

class Puska
{
private:
	enum { NABOJU = 5 };
	GLMmodel *model;																				//ukazatel na vykreslovany model
	bool vykresluj;																					//povoli/zakaze vykresleni zbrane - implicitne true
	float uhel, poziceX, poziceY, poziceZ;									//uhel otoceni podle osy Y, pozice v prostoru
	float zvetseni;																					//modifikator zvetseni
	int zasobnik;
	KourPoVystrelu kour;
protected:
	void kresliNaboj();
public:
	Puska();
	~Puska();
	void nabij()		{ zasobnik = NABOJU; }
	bool maNaboje()	{ return zasobnik > 0; }
	bool vystrel();
	void vykresli();
	void povolVykresleni();
	void zakazVykresleni();
	bool vykreslujeSe();																		//vrati true pokud se zbran vykresluje
	void nactiTextury() { kour.nactiTextury(); }
	void zmenPozici(float, float, float);
	void zmenOtoceni(float);
	void zmenZvetseni(float);
};

class Strelnice
{
private:
	enum { OBJEKTU = 4 };																		//pocet objektu v d-listu (stena, zakladna...)
	unsigned prvky;																					//d-list uchovavajici prvky strelnice
	Objekt *stena, *zakladna, *stolek, *strecha;
protected:
	void vytvorDList();
	void novyList(unsigned, Objekt*);
public:
	Strelnice();
	~Strelnice();
	void vykresli();
};

class Skybox
{
private:
	enum { MAX = 6, SVET_VYSKA = 100, SVET_SIRKA = 120 };
	GLuint texturaID[MAX];																	//id textur
public:
	Skybox();
	~Skybox()	{ }
	void nactiTextury();
	void vykresli();
};

#endif // OBJEKTY_H_INCLUDED
