#include "kour.h"
#include "../grafika.h"

///konstruktor tridy
KourPoVystrelu::KourPoVystrelu()
{
	textura = 0;
	zobrazKour = false;
	poziceX = poziceY = poziceZ = 0.0;
}

///zmeni pozici koure
void KourPoVystrelu::zmenPozici(GLfloat x, GLfloat y, GLfloat z)
{
	poziceX = x;
	poziceY = y;
	poziceZ = z;
}

///nacte textury koure
void KourPoVystrelu::nactiTextury()
{
	glGenTextures(MAX, texturaID);
	Image* image = NULL;

	char jmenoSouboru[128];
	for(int i=0; i < MAX; i++) {
		memset(jmenoSouboru, '\0', 128 * sizeof(char));
		sprintf(jmenoSouboru, "textury/Explode%d.bmp", i+1);
		image = LoadBMP(jmenoSouboru);
		if (image) {
			setTexture(texturaID[i], image);
			delete image;
		}
	}
}

///vykresli kour
void KourPoVystrelu::vykresli()
{
	if(textura >= MAX){
		textura = 0;
		zobrazKour = false;
	}

	if (zobrazKour) {
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE, GL_ONE);
		glBindTexture(GL_TEXTURE_2D, texturaID[textura]);

		glPushMatrix();
		glTranslated(poziceX, poziceY, poziceZ);
		glNormal3f(0.0, 1.0, 1.0);
		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3d(-SIRKA/2.0, -VYSKA/2.0, 0.0);
			glTexCoord2f(1.0, 0.0); glVertex3d( SIRKA/2.0, -VYSKA/2.0, 0.0);
			glTexCoord2f(1.0, 1.0); glVertex3d( SIRKA/2.0,  VYSKA/2.0, 0.0);
			glTexCoord2f(0.0, 1.0); glVertex3d(-SIRKA/2.0,  VYSKA/2.0, 0.0);
		glEnd();
		glPopMatrix();

		glDisable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
		textura++;
	}
}
