#ifndef PRIMITIVA_H_INCLUDED
#define PRIMITIVA_H_INCLUDED

#include <windows.h>
#include <GL/gl.h>

class Objekt
{
private:
	enum { MAX = 24, SLOZKY = 4 };
	unsigned dlist;
	float koefDeleni;
	GLfloat vrcholy[MAX];
	GLfloat ambientni[SLOZKY];
	GLfloat difuzni[SLOZKY];
	GLfloat odlesky[SLOZKY];
	GLfloat koefOdlesku;
protected:
	void vykresliSteny();
	void rozdelPlochu(float, float, float, const float, const float, const float);
	float pomerStran(const float&, const float&);
	void spocitejZmenseni(const float&, const float&, float&, float&, float&, float&);
	int najdiDelitele(int, int);
public:
	Objekt(GLfloat *, float);
	Objekt(Objekt &);
	Objekt(GLfloat *, float, GLfloat *, GLfloat *, GLfloat *, GLfloat);
	~Objekt() { }
	Objekt operator=(const Objekt &);
	void nastavMaterial(GLfloat *, GLfloat *, GLfloat *, GLfloat);
	void vykresli();
};

#endif // PRIMITIVA_H_INCLUDED
