#include "terc.h"
#include <GL/glut.h>
#include "../grafika.h"

///nastaveni materialu pro zakladnu
GLfloat ambientni[]		= {1.0, 0.58, 0.39, 0.5};	//odraz ambientni slozky (svetla z okoli)
GLfloat difuzni[]			= {1.0, 0.58, 0.39, 1.0};	//odraz difuzni slozky svetla
GLfloat odlesky[]			= {0.3, 0.0, 0.3, 1.0};			//barva odlesku
GLfloat koefOdlesku		= 5.0;											//koeficient odlesku

///implicitni konstruktor
Terc::Terc(GLfloat pozText)
{
	zasahu = 0;
	texturaID = 0;
	bez_textury = true;
	vykresliTerc = true;
	poziceTextu = pozText;
	poziceX = poziceY = poziceZ = 0.0;
}

///namapuje obrazek na plosku terce
void Terc::nactiTextury(char *jmenoSouboru)
{
	bez_textury = false;
	glGenTextures(1, &texturaID);

	Image *obrazek = LoadBMP(jmenoSouboru);
	if (obrazek) {
		setTexture(texturaID, obrazek);
		delete obrazek;
	}
	else
		bez_textury = true;
}

///zmeni aktualni pozici terce
void Terc::zmenPozici(GLfloat x, GLfloat y, GLfloat z)
{
	poziceX = x;
	poziceY = y;
	poziceZ = z;
}

///zjisti zda se hrac trefil do terce
void Terc::trefilSe(GLfloat xT, GLfloat yT, GLfloat xM, GLfloat yM)
{
	if (((xT - vratDelku() <= xM) && (xT + vratDelku() >= xM)) && (yT <= yM && (yT + vratVysku() >= yM)))
		zasahu++;
}

///vykresli text s poctem zasahu
void Terc::kresliZasahy()
{
	char retezec[128];
	memset(retezec, '\0', 128 * sizeof(char));
	sprintf(retezec, "Pocet zasahu: %d", zasahu);

	for (int i = 0; i < 128; i++) {
		if (retezec[i] == '\0') break;
		glutStrokeCharacter(GLUT_STROKE_ROMAN, retezec[i]);
	}
}

///vykreslovaci funkce
void Terc::vykresli()
{
	glEnable(GL_TEXTURE_2D);
	if (vykresliTerc) {
		if (bez_textury) {
			glMaterialfv(GL_FRONT, GL_AMBIENT, ambientni);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, difuzni);
			glMaterialfv(GL_FRONT, GL_SPECULAR, odlesky);
			glMaterialf(GL_FRONT, GL_SHININESS, koefOdlesku);
		}
		else
			glBindTexture(GL_TEXTURE_2D, texturaID);

		glPushMatrix();
		glTranslated(poziceX, poziceY, poziceZ);

		glNormal3f(0.0, 1.0, 1.0);
		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3d(SIRKA/2.0, 0.0, 0.0);
			glTexCoord2f(1.0, 0.0); glVertex3d(-SIRKA/2.0, 0.0, 0.0);
			glTexCoord2f(1.0, 1.0); glVertex3d(-SIRKA/2.0, VYSKA, 0.0);
			glTexCoord2f(0.0, 1.0); glVertex3d(SIRKA/2.0, VYSKA, 0.0);
		glEnd();
		glPopMatrix();

		glPushMatrix();
			glEnable(GL_BLEND);
			glBlendFunc(GL_ZERO, GL_CONSTANT_COLOR);
			glColor4f(1.0, 1.0, 1.0, 1.0);
			glTranslated(poziceTextu, 8.0, 4.0);
			glScalef(0.002, 0.002, 0.002);
			kresliZasahy();
			glDisable(GL_BLEND);
		glPopMatrix();
	}
	glDisable(GL_TEXTURE_2D);
}
