#include "zamerovac.h"
#include <windows.h>
#include <GL/gl.h>

const float SIRKA = 0.1;
const float VYSKA = 0.6;

///konstruktor tridy
Zamerovac::Zamerovac()
{
	poziceX = poziceY = poziceZ = 0.0;
}

///zmeni pozici zamerovace
void Zamerovac::zmenPozici(float x, float y, float z)
{
	poziceX = x;
	poziceY = y;
	poziceZ = z;
}

///vykresli zamerovac
void Zamerovac::vykresli()
{
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);

	glPushMatrix();
		glTranslated(poziceX, poziceY, poziceZ);
		glBegin(GL_POLYGON);
			glVertex3d(-SIRKA/2.0, VYSKA/2.0, 0.0);
			glVertex3d(-SIRKA/2.0,-VYSKA/2.0, 0.0);
			glVertex3d( SIRKA/2.0,-VYSKA/2.0, 0.0);
			glVertex3d( SIRKA/2.0, VYSKA/2.0, 0.0);
		glEnd();
	glPopMatrix();

	glPushMatrix();
		glTranslated(poziceX, poziceY, poziceZ);
		glBegin(GL_POLYGON);
			glVertex3d(-VYSKA/2.0, SIRKA/2.0, 0.0);
			glVertex3d(-VYSKA/2.0,-SIRKA/2.0, 0.0);
			glVertex3d( VYSKA/2.0,-SIRKA/2.0, 0.0);
			glVertex3d( VYSKA/2.0, SIRKA/2.0, 0.0);
		glEnd();
	glPopMatrix();

	glDisable(GL_BLEND);
}
