#include "grafika.h"
#include "objekty.h"

///konstruktor Skyboxu
Skybox::Skybox()
{
	memset(texturaID, 0, MAX * sizeof(GLuint));
}

///nacte textury ze souboru
void Skybox::nactiTextury()
{
	glGenTextures(MAX, texturaID);
	Image* image = NULL;

	char jmenoSouboru[128];
	for(int i=0; i < MAX; i++) {
		memset(jmenoSouboru, '\0', 128 * sizeof(char));
		sprintf(jmenoSouboru, "textury/skybox%d.bmp", i);
		image = LoadBMP(jmenoSouboru);
		if (image) {
			setTexture(texturaID[i], image);
			delete image;
		}
	}
}

void Skybox::vykresli()
{
	glEnable(GL_TEXTURE_2D);

	///predni strana
	glBindTexture(GL_TEXTURE_2D, texturaID[2]);
	glBegin(GL_QUADS);
		glNormal3f(0.0, 1.0, 1.0);
		glTexCoord2f(0.0, 0.0); glVertex3d( SVET_SIRKA, 0, SVET_SIRKA);
		glTexCoord2f(1.0, 0.0); glVertex3d(-SVET_SIRKA, 0, SVET_SIRKA);
		glTexCoord2f(1.0, 1.0); glVertex3d(-SVET_SIRKA, SVET_VYSKA, SVET_SIRKA);
		glTexCoord2f(0.0, 1.0); glVertex3d( SVET_SIRKA, SVET_VYSKA, SVET_SIRKA);
	glEnd();

	///zadni
	glBindTexture(GL_TEXTURE_2D, texturaID[0]);
	glBegin(GL_QUADS);
		glNormal3f(0.0, 1.0,-1.0);
		glTexCoord2f(0.0, 0.0); glVertex3d(-SVET_SIRKA, 0, -SVET_SIRKA);
		glTexCoord2f(1.0, 0.0); glVertex3d( SVET_SIRKA, 0, -SVET_SIRKA);
		glTexCoord2f(1.0, 1.0); glVertex3d( SVET_SIRKA, SVET_VYSKA, -SVET_SIRKA);
		glTexCoord2f(0.0, 1.0); glVertex3d(-SVET_SIRKA, SVET_VYSKA, -SVET_SIRKA);
	glEnd();

	///leva
	glBindTexture(GL_TEXTURE_2D, texturaID[3]);
	glBegin(GL_QUADS);
		glNormal3f(-1.0, 1.0, 0.0);
		glTexCoord2f(0.0, 0.0); glVertex3d(-SVET_SIRKA, 0,  SVET_SIRKA);
		glTexCoord2f(1.0, 0.0); glVertex3d(-SVET_SIRKA, 0, -SVET_SIRKA);
		glTexCoord2f(1.0, 1.0); glVertex3d(-SVET_SIRKA, SVET_VYSKA, -SVET_SIRKA);
		glTexCoord2f(0.0, 1.0); glVertex3d(-SVET_SIRKA, SVET_VYSKA, SVET_SIRKA);
	glEnd();

	///prava
	glBindTexture(GL_TEXTURE_2D, texturaID[4]);
	glBegin(GL_QUADS);
		glNormal3f(1.0, 1.0, 0.0);
		glTexCoord2f(0.0, 0.0); glVertex3d(SVET_SIRKA, 0, -SVET_SIRKA);
		glTexCoord2f(1.0, 0.0); glVertex3d(SVET_SIRKA, 0,  SVET_SIRKA);
		glTexCoord2f(1.0, 1.0); glVertex3d(SVET_SIRKA, SVET_VYSKA,  SVET_SIRKA);
		glTexCoord2f(0.0, 1.0); glVertex3d(SVET_SIRKA, SVET_VYSKA, -SVET_SIRKA);
	glEnd();

	///vrsek
	glBindTexture(GL_TEXTURE_2D, texturaID[5]);
	glBegin(GL_QUADS);
		glNormal3f(0.0, 1.0, 0.0);
		glTexCoord2f(0.0, 0.0); glVertex3d(SVET_SIRKA, SVET_VYSKA,  SVET_SIRKA);
		glTexCoord2f(1.0, 0.0); glVertex3d(-SVET_SIRKA, SVET_VYSKA, SVET_SIRKA);
		glTexCoord2f(1.0, 1.0); glVertex3d(-SVET_SIRKA, SVET_VYSKA, -SVET_SIRKA);
		glTexCoord2f(0.0, 1.0); glVertex3d(SVET_SIRKA, SVET_VYSKA,  -SVET_SIRKA);
	glEnd();

	///spodek
	glBindTexture(GL_TEXTURE_2D, texturaID[1]);
	glBegin(GL_QUADS);
		glNormal3f(0.0,1.0, 0.0);
		glTexCoord2f(0.0, 0.0); glVertex3d(SVET_SIRKA, 0,  -SVET_SIRKA);
		glTexCoord2f(1.0, 0.0); glVertex3d(-SVET_SIRKA, 0, -SVET_SIRKA);
		glTexCoord2f(1.0, 1.0); glVertex3d(-SVET_SIRKA, 0, SVET_SIRKA);
		glTexCoord2f(0.0, 1.0); glVertex3d(SVET_SIRKA, 0,  SVET_SIRKA);
	glEnd();

	glDisable(GL_TEXTURE_2D);
}
