#include "grafika.h"
#include "objekty.h"

///konstruktor tridy strelnice
Strelnice::Strelnice()
{
	prvky = glGenLists(OBJEKTU);

	GLfloat vrcholy1[] = {								//definice vrcholu zakladny
		-15.0, 0.0,-5.0,
		-15.0, 0.0, 5.0,
		 15.0, 0.0, 5.0,
		 15.0, 0.0,-5.0,
		-15.0, 2.0,-5.0,
		-15.0, 2.0, 5.0,
		 15.0, 2.0, 5.0,
		 15.0, 2.0,-5.0
	};

	GLfloat vrcholy2[] = {								//definice vrcholu steny
		-3.0, 0.0,-0.25,
		-3.0, 0.0, 0.25,
		 3.0, 0.0, 0.25,
		 3.0, 0.0,-0.25,
		-3.0, 8.0,-0.25,
		-3.0, 8.0, 0.25,
		 3.0, 8.0, 0.25,
		 3.0, 8.0,-0.25
	};

	GLfloat vrcholy3[] = {								//definice vrcholu stolek
		-1.0, 0.0,-4.25,
		-1.0, 0.0, 4.25,
		 1.0, 0.0, 4.25,
		 1.0, 0.0,-4.25,
		-1.0, 4.0,-4.25,
		-1.0, 4.0, 4.25,
		 1.0, 4.0, 4.25,
		 1.0, 4.0,-4.25
	};

	GLfloat vrcholy4[] = {								//definice vrcholu strechu
		-3.5, 0.0,-5.0,
		-3.5, 0.0, 5.0,
		 3.5, 0.0, 5.0,
		 3.5, 0.0,-5.0,
		-3.5, 0.25,-5.0,
		-3.5, 0.25, 5.0,
		 3.5, 0.25, 5.0,
		 3.5, 0.25,-5.0
	};

	///nastaveni materialu pro zakladnu
	GLfloat amb[]		= {0.35, 0.35, 0.35, 0.5};	//odraz ambientni slozky (svetla z okoli)
	GLfloat dif[]		= {0.35, 0.35, 0.35, 1.0};	//odraz difuzni slozky svetla
	GLfloat spec[]	= {0.3, 0.2, 0.1, 1.0};			//barva odlesku
	GLfloat koef		= 5.0;											//koeficient odlesku

	///nastaveni materialu pro stenu
	GLfloat amb2[]	= {0.58, 0.36, 0.24, 0.5};
	GLfloat dif2[]	= {0.58, 0.36, 0.24, 0.5};
	GLfloat spec2[]	= {0.1, 0.1, 0.1, 1.0};
	GLfloat koef2		= 10.0;

	///nastaveni materialu pro stolek
	GLfloat amb3[]	= {0.54, 0.21, 0.81, 0.5};
	GLfloat dif3[]	= {0.54, 0.21, 0.81, 1.0};
	GLfloat spec3[]	= {0.2, 0.2, 0.2, 1.0};
	GLfloat koef3		= 15.0;

	///nastaveni materialu pro strechu
	GLfloat amb4[]	= {0.7, 0.0, 0.0, 0.5};
	GLfloat dif4[]	= {0.7, 0.0, 0.0, 1.0};
	GLfloat spec4[]	= {0.4, 0.0, 0.0, 1.0};
	GLfloat koef4		= 20.0;

	zakladna	= new Objekt(vrcholy1, 100.0, amb, dif, spec, koef);
	stena			= new Objekt(vrcholy2, 50.0, amb2, dif2, spec2, koef2);
	stolek		= new Objekt(vrcholy3, 50.0, amb3, dif3, spec3, koef3);
	strecha		= new Objekt(vrcholy4, 50.0, amb4, dif4, spec4, koef4);
}

///destruktor tridy
Strelnice::~Strelnice()
{
	if (zakladna)		delete zakladna;
	if (stena)			delete stena;
}

///vykreslovaci funkce tridy strelnice
void Strelnice::vykresli()
{
	vytvorDList();

	initDraw();				///vykresleni zakladny
	glTranslated(0.0,-2.0, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	closeDraw(prvky+1);

	initDraw();				///vykresleni steny 1
	glTranslated(4.5, 0.0, 8.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	closeDraw(prvky+2);

	initDraw();				///vykresleni steny 2
	glTranslated(-4.5, 0.0, 8.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	closeDraw(prvky+2);

	initDraw();				///vykresleni stolku
	glTranslated(0.0, 0.0, 6.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	closeDraw(prvky+3);

	initDraw();				///vykresleni strechy
	glTranslated(0.0, 8.0, 8.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	closeDraw(prvky+4);

	initDraw();				///vykresleni podstavce pro terče
	glTranslated(0.0, 0.0,-12.4);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glScalef(1.0, 1.0, 1.2);
	closeDraw(prvky+3);

	initDraw();				///vykresleni zdi tercu
	glTranslated(0.0, 0.0,-14.0);
	glRotatef(-270.0, 0.0, 1.0, 0.0);
	glScalef(0.2, 1.0, 20.0);
	closeDraw(prvky+2);

	initDraw();				///vykresleni strechy tercu
	glTranslated(0.0, 8.0,-13.5);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glScalef(0.6, 1.0, 1.0);
	closeDraw(prvky+4);
}

///vytvori d-list z komponent strelnice
void Strelnice::vytvorDList()
{
	novyList(prvky+1, zakladna);
	novyList(prvky+2, stena);
	novyList(prvky+3, stolek);
	novyList(prvky+4, strecha);
}

///vytvori novou polosku d-listu
void Strelnice::novyList(unsigned seznam, Objekt *prvek)
{
	glNewList(seznam, GL_COMPILE);
		prvek->vykresli();
	glEndList();
}
